#!/usr/bin/perl

#######################################################################################
# adm19.pl : modification de mot de passe - Projet MINAL2.05
#######################################################################################

require './minal2.cfg';
require './minal2sp.pl';

#--- avert admin
$in{dest} = 'a';

#-- module cgi
use CGI qw/:standard/;
$| = 1;
$query = new CGI;

#-- entrees
foreach $key ($query->param()) {
	next if ($key =~ /^\s*$/);
	next if ($query->param($key) =~ /^\s*$/);
	next if ($query->param($key) =~ /<!--(.|\n)*-->/);
	$in{$key} = $query->param($key);
	$in{$key} =~ s/://g;
	$in{$key} =~ s/;//g;
	$in{$key} =~ s/\|//g;
}

#-- identification du responsable
($login,$pw) = &trouve($ENV{REMOTE_USER},1,':',$acc_usr);

#--- controle champs
if (!$login){
	&confirm('<H1>Probl&#232;me</H1><H3>Aucun utilisateur identifi...</H3>');
} elsif (!$in{ex_pw} || !$in{new_pw1} || !$in{new_pw2}){
	&confirm('<H1>Probl&#232;me</H1><H3>Vous devez saisir tous les champs...<br><a href="javascript:history.back()">Corrigez...</a></H3>');
} elsif (crypt($in{ex_pw},'A.') ne $pw){
	&confirm('<H1>Probl&#232;me</H1><H3>Votre ancien mot de passe n\'est pas le bon...<br><a href="javascript:history.back()">Corrigez...</a></H3>');
} elsif ($in{new_pw1} ne $in{new_pw2}){
	&confirm('<H1>Probl&#232;me</H1><H3>Le nouveau mot de passe et sa confirmation sont diffrents...<br><a href="javascript:history.back()">Corrigez...</a></H3>');
} elsif ($in{new_pw1} !~ /^\w{4,10}$/){
	&confirm('<H1>Probl&#232;me</H1><H3>Le format pour le nouveau mot de passe n\'est pas correct...<br><a href="javascript:history.back()">Corrigez...</a></H3>');
}


	
#--- fichier /etc/passd
@tab = &ouvre($fic_usr);
# classement
@tab = &classe('nc3',':',@tab);
for($i=0;$i<@tab;$i++){
	($log,$pw,@suite) = split(/:/,$tab[$i]);
	next if ($log ne $login);
	$tab[$i] = join(':',($log,crypt($in{new_pw1},'A.'),@suite));
	$modif1 = 1;
	last;
}
&maj_bdd($fic_usr,@tab) if ($modif1);


#--- fichier usr_file
@tab = &ouvre($acc_usr);
for($i=0;$i<@tab;$i++){
	($nom,$pw) = split(/:/,$tab[$i]);
	next if ($nom ne $login);
	$tab[$i] = join(':',($log,crypt($in{new_pw1},'A.')));
	$modif2 = 1;
	last;
}
&maj_bdd($acc_usr,@tab) if ($modif2);


#--- message confirmation
$info .= '<CENTER><hr><H1>Changement de mot de passe</H1><hr></CENTER><BR>'."\n";
$info .= 'Le changement s\'est bien droul.<br>'."\n" if ($modif1 && $modif2);
$info .= 'Il y a eut un problme dans l\'enregistrement des nouvelles donnes..<br> Contactez l\'administrateur rseau'."\n" if (!$modif1 || !$modif2);

&confirm($info);









