#!/usr/bin/perl

##################################################################
# adm4.pl : modification responsable - Projet MINAL2.1
##################################################################

require './minal2.cfg';
require './minal2sp.pl';

#--- avert admin
$in{dest} = 'a';

#-- module cgi
use CGI qw/:standard/;
$| = 1;
$query = new CGI;

#-- entrees
foreach $key ($query->param()) {
	next if ($key =~ /^\s*$/);
	next if ($query->param($key) =~ /^\s*$/);
	next if ($query->param($key) =~ /<!--(.|\n)*-->/);
	$in{$key} = $query->param($key);
	$in{$key} =~ s/://g;
	$in{$key} =~ s/;//g;
	$in{$key} =~ s/\|//g;
}

#--- controle champs
if (!$in{login}){
	&confirm('<H1>Probl&#232;me</H1><H2>Aucun utilisateur choisi...</H2>');
}

#--- groupes
@tab = &list_grp;
@tab = &classe('ac1','x',@tab);
if (!(@tab)){
	&confirm("<center><hr><H1>Problme</H1><hr></center><h2>Aucun groupe d\'utilisateurs n\'est encore dfini...<br><br>Contactez votre responsable</h2>");
}

#-- controle existence dans fichier /etc/passwd
($login,$pw,$uid,$gid,$nompren,$rep,$shell) = &trouve($in{login},1,':',$fic_usr);
if (!$login){
	$info .= '<CENTER><hr><H1>Modification d\'un utilisateur :</H1><hr></CENTER><BR>'."\n";
	$info .= '<h2>Problme</h2>L\'utilisateur ne figure plus dans la base</b><BR>'."\n";
	&confirm($info);
}


#--- confirm
#--- controle javascript des champs obligatoires
$js  = '<SCRIPT LANGUAGE="JavaScript">'."\n";
$js .= '<!-- Debut script'."\n";
$js .= 'function verif() {'."\n";
$js .= 'if (0){'."\n";
$js .= '} else if (!document.rens.nompren.value){'."\n";
$js .= '	alert("Vous devez saisir un nom")'."\n";
$js .= '} else {'."\n";
$js .= '	document.rens.submit()'."\n";
$js .= '}}'."\n";
$js .= '//  Fin script -->'."\n";
$js .= '</SCRIPT>'."\n";
$info .= $js."\n";
$info .= '<CENTER><hr><H1>Modification de responsable</H1><hr></CENTER><BR>'."\n";
$info .= '<H2>Vous pouvez modifier les informations suivantes :</H2>'."\n";
$info .= '<FORM METHOD=POST ACTION="'.$rep_cgi.'/adm5.pl" name="rens">'."\n";
$info .= '<CENTER><TABLE BORDER=0 WIDTH=550 CELLPADDING=5 CELLSPACING=5>'."\n";

$info .= '<TR><TD width=280>Modifier les Nom, Prnom :'."\n";
$info .= '</TD><TD><INPUT NAME="nompren" TYPE="TEXT" size=30 VALUE="'.$nompren.'"></TD></TR>'."\n";

$info .= '<TR><TD>Nom d\'utilisateur (non modifiable)&nbsp;:'."\n";
$info .= '</TD><TD>'.$login.'</TD></TR>'."\n";

$info .= '<TR><TD>Nouveau mot de passe :'."\n";
$info .= '<br><font size=2 color="#ff00ff">(entre 4 et 10 caractres, lettres ou chiffres sans espaces)</font>'."\n";
$info .= '</TD><TD><INPUT NAME="pw" TYPE="TEXT" size=20 maxlength=10 VALUE=""></TD></TR>'."\n";

#--- groupes resp ou simple membre
$info .= '<TR><TD colspan=2>'."\n";
$info .= '&nbsp;<br>Cochez   le (ou les) groupe(s) qui auront <b>'.$nompren.'</b> comme <u>responsable</u> ou/et comme <u>simple membre</u> :<br><br>'."\n";
$info .= '</TD></tr>'."\n";

$info .= '<TR><td valign="top">'."\n";
$info .= '<font size=2 color="#ccccff">Etre responsable d\'un groupe autorise la personne  :<br>'."\n";
$info .= '&nbsp;&nbsp;&nbsp;- grer les membres de ce groupe<br>'."\n";
$info .= '&nbsp;&nbsp;&nbsp;- avoir accs aux rpertoires de l\'ensemble des membres</font><br><br>'."\n";
$info .= '</td><td valign="top">'."\n";
$info .= '<font size=2 color="#ccccff">Etre membre d\'un groupe autorise la personne  :<br>'."\n";
$info .= '&nbsp;&nbsp;&nbsp;- avoir accs au rpertoire du groupe<br>'."\n";
$info .= '</TD></tr>'."\n";
$info .= '</table><br>'."\n";

#--- tableau des groupes
$info .= '<CENTER><TABLE BORDER=0 WIDTH=400 CELLPADDING=1 CELLSPACING=1>'."\n";
$info .= '<tr><td align="center" width=180><b>Groupe</b></td>'."\n";
$info .= '<td align="center"><b>Responsable</b></td>'."\n";
$info .= '<td align="center"><b>Membre</b></td></tr>'."\n";

foreach $nom (@tab) {
	$info .= '<td align="center">'."\n";
	$info .= $nom."\n";
	$info .= '</td>'."\n";

	$info .= '<td  align="center"><input type="checkbox" name="resp_'.$nom.'" value="1"';
	%membre_resp = &memb_grp('resp_'.$nom,'h');
	$info .= ' checked' if ($membre_resp{$login});
	$info .= '>'."\n";
	$info .= '</td>'."\n";

	$info .= '<td  align="center"><input type="checkbox" name="grp_'.$nom.'" value="1"';
	%membre_mem = &memb_grp('grp_'.$nom,'h');
	$info .= ' checked' if ($membre_mem{$login});
	$info .= '>'."\n";
	$info .= '</td></tr>'."\n";
}
$info .= '</table><br>'."\n";

$info .= '<input type="hidden" name="login" value="'.$login.'">'."\n";
$info .= '<INPUT NAME="Envoi" TYPE="button" VALUE="Enregistrer la modification" onClick="verif()"> '."\n";
$info .= '</CENTER></FORM><BR>'."\n";

&confirm($info);



