#!/usr/bin/perl

##################################################################
# adm6.pl : suppression utilisateur - Projet MINAL2.1
##################################################################

require './minal2.cfg';
require './minal2sp.pl';

#--- avert admin
$in{dest} = 'a';

#-- module cgi
use CGI qw/:standard/;
$| = 1;
$query = new CGI;

#-- entrees
foreach $key ($query->param()) {
	next if ($key =~ /^\s*$/);
	next if ($query->param($key) =~ /^\s*$/);
	next if ($query->param($key) =~ /<!--(.|\n)*-->/);
	$in{$key} = $query->param($key);
	$in{$key} =~ s/://g;
	$in{$key} =~ s/;//g;
	$in{$key} =~ s/\|//g;
}

#--- controle champs
if (!$in{login}){
	&confirm('<H1>Probl&#232;me</H1><H2>Aucun utilisateur choisi...</H2>');
}

#--- fichier /etc/passwd
&mod_passwd($in{login},'','','sup');

#--- fichier /etc/group
@groupes = &list_grp;
foreach $group (@groupes){
	&mod_usr_grp($in{login},'grp_'.$group,'sup');
}

#--- sauvegarde des donnes si demand
if ($in{sav_rep}){
	$result_save = &cp_rep($in{login});
	push(@resume_save,$result_save);
}

#--- sup rep perso
&del_rep('/home/minal2/rep/'.$in{login});

#--- sup rep profil
&del_rep('/home/minal2/profil/'.$in{login});

#--- affichage
$info .= '<CENTER><hr><H1>Suppression d\'un utilisateur</H1><hr></CENTER><BR>'."\n";
$info .= 'L\'opration s\'est correctement droule<br>'."\n";
if ($in{sav_rep}){
	$info .= '<br>Rsultats de la sauvegarde : <ul><li> rpertoire de sauvegardes sur le serveur <b>'.$rep_save_base.'/</b>'."\n";
	foreach(@resume_save){
		($fic_org,$fic_cp,$rep_org,$rep_cp,$taille) = split('',$_);
		$taille_tot += $taille;
		$fic_cp_tot += $fic_cp;
	}
	$info .= '<li> nombre de fichiers sauvegardes :  <b>'.$fic_cp_tot.'</b>'."\n";
	$info .= '<li> place occupe par cette sauvegarde :  <b>'.$taille_tot.'</b> octets'."\n";
	$info .= '</ul>'."\n";
}
$info .= 'Supprimer un <a href="./adm3.pl?desti=sup">autre utilisateur</a>'."\n";


#--- envoi
&confirm($info);



