#!/usr/bin/perl

#########################################################
# minal2sp.pl - Projet MINAL2.05
#########################################################


if ($ENV{SCRIPT_NAME} =~ /dbsp.pl/){
	print "Content-type: text/html\n\n";
	print '<html><body>'."\n";
	print '<H1>Forbidden</H1>'."\n";
	print '<i>You don\'t have permission to access to this script on this server.</i>'."\n";
	print '</body></html>';
	exit;
}

#----------sub de tri par lettre
sub par_noms {
	(uc($res_ord{$a}) cmp uc($res_ord{$b})) || (uc($a) cmp uc($b));
}

#----------sub de tri par nombre
sub par_nombre {
	($res_ord{$a}) <=> ($res_ord{$b});
}

#----------sub de tri par ordre date
sub par_date {
	($res_ord_1{$a} <=> $res_ord_1{$b}) || ($res_ord_2{$a} <=> $res_ord_2{$b});
}


#----------sub d'envoi de mail
sub send_email {
	if (open (MAIL, "|$mailprog -t")) {
		print MAIL ('To: '.$mail_dest."\n");
		print MAIL ('From: '.$mail_from."\n");
		print MAIL ('Subject: '.$mail_sujet."\n\n");
		print MAIL ("$texte \n");
		close (MAIL);
	} else {
		&avert($in{dest},"Pb.... Impossible d\'envoyer le message au destinataire pour l\'instant.<BR>Renouvellez votre demande ult&#233;rieurement.<BR>Merci");
	}
}

#------- sub d'affichage de date format 28:07:98
sub date {
	#--date du jour
	@date=gmtime(time());
	$an = 1900 + $date[5];
	$jr = $date[3];
	$ms=$date[4];
	$ms++;
	$ms = '0'.$ms if ($ms<10);
	$la_date = $jr.':'.$ms.':'.$an;
	return($la_date);
}

#------- sub de convertion de date : 907556687 -> 28:07:98
sub conv {
	@date=gmtime($_[0]);
	$an = 1900 + $date[5];
	$jr = $date[3];
	$ms=$date[4];
	$ms++;
	$ms = '0'.$ms if ($ms<10);
	$jr = '0'.$jr if ($jr<10);
	$la_date = $jr.':'.$ms.':'.$an;
	return($la_date);
}


#---sub de classement multiple par le(s) n de champ(s) transmis (utilise mini_class)
sub classe {
	# $type_class : nc1 pour num champ 1 croissant, ad3 pour alpha champ 3 decroissant, dc7 pour date champ 7 croissant
	# $type_class : nc8,ad3 pour num-croissant-ch8 puis alpha-decroissant-ch3
	# $separ : separateur
	# @tab_class : tab non classe
	($type_class,$separ,@tab_class) = @_;
	@crit_class = @nul;
	@type_classement = split(/,/,$type_class);
	foreach $type_classe (@type_classement){
		$champ_class = $type_classe;
		$champ_class =~ s/^..//;
		if (!@crit_class){
			@med_class = &mini_classe($type_classe,$separ,@tab_class);
		} else {
			$dif_tab = 0;
			@fin_class = @nul;
			@min_tab_class = @nul;
			for($i=0;$i<@med_class;$i++){
				@val_med_i = split(/$separ/,$med_class[$i]);
				@val_med_ii = split(/$separ/,$med_class[$i+1]);
				foreach(@crit_class){
					if (($val_med_i[$_-1] ne $val_med_ii[$_-1]) && ($ex_type_classe !~ /e/)){
						$dif_tab = 1;
						last;
					} elsif ((int($val_med_i[$_-1]) != int($val_med_ii[$_-1])) && ($ex_type_classe =~ /e/)){
						$dif_tab = 1;
						last;
					}
				}
				if (($dif_tab)&&(@min_tab_class)){
					# element different du suivant mais deja element tab intermed
					push(@min_tab_class,$med_class[$i]);
					@res_class = &mini_classe($type_classe,$separ,@min_tab_class);
					push(@fin_class,@res_class);
					@min_tab_class = @nul;
					$dif_tab = 0;
				} elsif (($dif_tab)&&(!@min_tab_class)){
					# element different du suivant et pas element tab intermed
					push(@fin_class,$med_class[$i]);
					$dif_tab = 0;
				} elsif (!$dif_tab){
					# element egal au suivant
					push(@min_tab_class,$med_class[$i]);
				}
			}
			@med_class = @fin_class;
		}
		push(@crit_class,$champ_class);
		$ex_type_classe = $type_classe;
	}
	return @med_class;
}


#---subsub de classement (utilis par classe)
sub mini_classe{
	($loc_class,$separ,@loc_tab) = @_;
	@intermed = @nul;
	%res_ord = %nul;
	%res_ord_1 = %nul;
	%res_ord_2 = %nul;
	$loc_champ = $loc_class;
	$loc_champ =~ s/^..//;
	for ($ii=0; $ii<@loc_tab; $ii++) {
		@loc_val = split(/$separ/,$loc_tab[$ii]);
		if (($loc_class =~ /a/)||($loc_class =~ /n/)){
			$res_ord{$ii} = $loc_val[$loc_champ-1];
		} elsif ($loc_class =~ /e/){
			$res_ord{$ii} = int($loc_val[$loc_champ-1]);
		} else {
			# tri date
			($jr,$ms,$an) = split(/:/,$loc_val[$loc_champ-1]);
			$res_ord_1{$ii} = $an;
			$res_ord_2{$ii} = $ms*100+$jr;
		}
	}
	@loc_trie = sort par_date keys(%res_ord_1) if ($loc_class =~ /d/);
	@loc_trie = sort par_noms keys(%res_ord) if ($loc_class =~ /a/);
	@loc_trie = sort par_nombre keys(%res_ord) if ($loc_class =~ /n/);
	@loc_trie = sort par_nombre keys(%res_ord) if ($loc_class =~ /e/);
	foreach(@loc_trie){
		push(@intermed,$loc_tab[$_]);
	}
	@intermed = reverse(@intermed) if ($loc_class =~ /r/);
	return @intermed;
}


#--- sub d'ouverture fichier
sub ouvre {
	$fichier = $_[0];
	@fic_ouvre = @nul;
	if (-e $fichier){
		open(FICHIER,$fichier) || &avert($in{dest},"Pb pour ouvrir fichier $fichier...");
		while (<FICHIER>) {
			chomp;
			push (@fic_ouvre,$_);
		}
		close FICHIER || &avert($in{dest},"Pb pour fermer fichier $fichier...");
	}
	return @fic_ouvre;
}

#--- sub de creation de fichier si pas existant
sub makif {
	$fichier = $_[0];
	if (!(-e $fichier)){
		open(FICHIER,">$fichier") || &avert($in{dest},"Pb pour crer fichier $fichier...");
		close FICHIER || &avert($in{dest},"Pb pour fermer fichier $fichier...");
        	chmod(0666, "$fichier");
        	return 1;
	} else {
		return 0;
	}
}


#--- sub d'untuntain de fichier transmis
sub untunt_fic{
	$nom_fichier = $_[0];
	$nom_fichier =~ s/^\///;
	@rept = split(/\//,$nom_fichier);
	@repertoire = @nul;
	foreach (@rept){
		if (/^([-\@\w\s.]+)$/) {
			push(@repertoire,$1);
		} else {
			&avert($in{dest},'<H1>Probleme</H1><H2>Nom de fichier  ne permettant pas d\'effectuer une opration sur le fichier '.$_[0].'</H2>');
		}
	}
	$fichier_final = join('/',@repertoire);
	$fichier_final =~ s/^/\// if ($_[0] =~ /^\//);
	return $fichier_final;
}

#--- sub d'avertissement en fonction du destinataire
sub avert {
	$dest = $_[0];		# destinataire message
	$message = $_[1];	# message a afficher
	if ($dest eq 'a'){
		# admin
		&confirm($message);
	} elsif ($dest eq 'user') {
		# usr
		&confirm_user($message);
	} else {
		# resp
		&confirm_u($message);
	}
}


#--- maj fichier bd 
sub maj_bdd{
	($fichier,@tableau) = @_;
	open(FICHIER,">$fichier") || &avert($in{dest},"Pb pour mettre a jour fichier $fichier...");
	foreach (@tableau) {
		print FICHIER "$_\n";
	}
	close FICHIER || &avert($in{dest},"Pb pour fermer fichier $fichier..");
}


#--- trouver  un enregistrement dans un tableau d'apres chaine recherchee
sub trouve{
	$chaine = $_[0];	# chaine recherchee
	$champ = $_[1];		# champ de recherche
	$separ = $_[2];		# separateur de champ
	$fichier = $_[3];	# fichier
	@tab_fic = &ouvre($fichier);
	foreach(@tab_fic) {
		@valeur = split(/$separ/,$_);
		if ($valeur[$champ-1] eq $chaine) {
			return(@valeur);
		}
	}
	return 0;
}


#--- supprime un enregistrement dans un tableau d'apres chaine recherchee
sub supprime{
	$chaine = $_[0];	# chaine recherchee
	$champ = $_[1];		# champ de recherche
	$separ = $_[2];		# separateur de champ
	$fic = $_[3];		# fichier
	$fichier = &untunt_fic($fic);
	@tabl = &ouvre($fichier);
	$numero = -1;
	for ($i=0; $i<@tabl; $i++) {
		@valeur = split(/$separ/,$tabl[$i]);
		if ($valeur[$champ-1] eq $chaine) {
			$numero = $i;
			last;
		}
	}
	return if ($numero == -1);
	@tabl[$numero...(@tabl-2)] = @tabl[$numero+1...(@tabl-1)];
	$supprime = pop(@tabl);
	&maj_bdd($fichier,@tabl);
	return 1;
}

#--- suppression de rep et sous rep
sub del_rep{
	push (@folders,$_[0]);	# repertoire a detruire
	# suppression fichiers
	foreach $folder (@folders){
		@fichiers_rep = &lirep($folder);
		foreach(@fichiers_rep){
			push(@folders,$_) if (-d $_);
			$nbre_fic++ if (-f $_);
			unlink(&untunt_fic($_)) if (-f $_);
		}
	}
	# suppression repertoires
	foreach (reverse @folders){
		rmdir(untunt_fic($_)) if (-d $_);
	}
	return ($nbre_fic.''.@folders);
}

#--- copie de rep et sous rep avec fichiers vers $rep_sauve (cfg) avec nom du rep de sauvegarde = date
#--- si la date ($save_the_date)  est fournie par le script appelant elle est utilise (cas pour plusieurs rep a sauvegarder)
#--- si elle n'est pa fournie, le sp en fournit une (valable juste pour cette sauvegarde)
#--- entree : noms des repertoires sous $rep_rep (@login) - sortie : nombre de fichiers  nombre de rep copis
sub cp_rep{
	# init
	@folders = @nul;
	@files = @nul;
	$rep_rep = '/home/minal2/rep';

	# rep destination
	 if (! $save_the_date){
		@date=gmtime(time());
		$save_the_date = join('-',($date[3],$date[4]++,1900 + $date[5])).'_'. join('-',($date[2],$date[1],$date[0]));
	}
	$rep_save_base = &untunt_fic($rep_sauve.'/'.$save_the_date);
	mkdir($rep_save_base,0777) if (! -e $rep_save_base);
	chmod(0777,$rep_save_base);

	# extraction : rep ou fichier ?
	foreach $cp_log (@_){

		# repertoire source des donnes
		$rep_src = '/home/minal2/rep/'.$cp_log;

		# repertoire a copier
		@folders = ($rep_src);
		push(@folders_final, $rep_src);

		# separation fichiers/rep
		foreach $folder (@folders){
			@fichiers_rep = &lirep($folder);
			foreach $cp_fic (@fichiers_rep){
				if (-d $cp_fic) {
					push(@folders,$cp_fic);
					push(@folders_final,$cp_fic);
				} elsif  (-f $cp_fic) {
					push(@files,$cp_fic);
				}
			}
		}
	}

	# creation rep
	# &map(@folders_final);
	foreach $cp_rep (@folders_final){
		$cp_rep =~ s/^$rep_rep//;
		$rep_dest = &untunt_fic($rep_save_base.$cp_rep);
		# nbre de creation reussies
		$result_cp_rep = $result_cp_rep + mkdir($rep_dest,0777) if (! -e $rep_dest);
		chmod(0777,$rep_dest);
	}

	# copie fichiers
	# &map(@files);
	foreach $cp_fic (@files){
		$cp_fic2 = $cp_fic;
		$cp_fic2 =~ s/^$rep_rep//;
		$taille_totale += -s $cp_fic;
		# nbre de copies reussies
		if ($cp_fic =~ /[^-\@a-zA-Z0-9 _.\/]/){
			$cp_fic2 =~ s/[^-a-zA-Z0-9_ .\/]//g;
			$result_cp_files = $result_cp_files + &copie_fic($cp_fic,&untunt_fic($rep_save_base.$cp_fic2));
		} else {
			$result_cp_files = $result_cp_files + link(&untunt_fic($cp_fic),&untunt_fic($rep_save_base.$cp_fic2));
		}
	}
	 return (@files.''.$result_cp_files.''.@folders_final.''.$result_cp_rep.''.$taille_totale);
}

#--- copie de fichier  : pb link certaines config
sub copie_fic {
	@cp_fic_src = &ouvre($_[0]);
	open(FICHIER,">$_[1]") || &avert($in{dest},"Problme pour crer le fichier $_[1]...");
	foreach(@cp_fic_src) {
		print FICHIER "$_\n";
	}
	close FICHIER || &avert($in{dest},"Problme pour fermer le fichier $_[1]..");
}


#--- lecture du contenu d'un repertoire
sub lirep {
	opendir(DIR,$_[0]);
	@fichiers_repertoires = map{m/^\.+$/ ? () : "$_[0]/$_"} readdir(DIR);
	closedir(DIR);
	return @fichiers_repertoires;
}

#--- mise au point
sub map{
	foreach(@_){
		$mapin .= '--'.$_.'<br>';
	}
	&confirm('Mise au point...<br>'.$mapin);
}


#--- trouve une donnee dans un tableau et retourne l'indice
sub trouve_ind{
	($chaine,$champ,$separ,@tableau_loc) = @_;
	$numero_loc = -1;
	for ($indic=0; $indic < @tableau_loc; $indic++) {
		@donnees_loc = split(/$separ/,$tableau_loc[$indic]);
		next if ($donnees_loc[$champ - 1] ne $chaine);
		$numero_loc = $indic;
	}
	return $numero_loc;
}


#---------sub d'envoi de message a l'administrateur
sub confirm {
$message = $_[0];
print "Content-type: text/html\n\n";
print '<html><head><title>MINAL - Administration</title></head>'."\n";
print '<body bgcolor="#000080" text="#ffffff" link="#ffff40" vlink="#ffff40">'."\n";
print '<font type="Arial">'."\n";
print "$message\n";
print '</font><BR><BR><BR><center><a href="'.$rep_cgi.'/adm0.pl"><img src="/img/but_list.gif" border=0 alt="Retour au menu administrateur"></a></center>'."\n";
print '</body></html>';
exit;
}

#---------sub d'envoi de message au responsable
sub confirm_u($message) {
$message = $_[0];
print "Content-type: text/html\n\n";
print '<html><head><title>MINAL - Gestion</title></head>'."\n";
print '<body bgcolor="#800080" text="#ffffff" link="#ffff40" vlink="#ffff40">'."\n";
print '<font type="Arial">'."\n";
print "$message\n";
print '</font><BR><BR><BR><center><a href="'.$rep_cgi.'/resp0.pl"><img src="/img/but_list.gif" border=0 alt="Retour au menu"></a></center>'."\n";
print '</body></html>';
exit;
}

#---------sub d'envoi de message a l'usr
sub confirm_user($message) {
$message = $_[0];
print "Content-type: text/html\n\n";
print '<html><head><title>MINAL - Utilisateur</title></head>'."\n";
print '<body bgcolor="#ffffff" text="#000000" link="#0000ff" vlink="#ff00ff">'."\n";
print '<font type="Arial">'."\n";
print "$message\n";
print '</font><BR><BR><BR><center><a href="/minal2.htm"><img src="/img/but_list.gif" border=0 alt="Retour au menu gnral"></a></center>'."\n";
print '</body></html>';
exit;
}

# ajout/sup d'utilisateur dans groupe (user,groupe,aj|sup) ; modifie /etc/group ; retourne 1
sub mod_usr_grp{
	@g_groupes = &ouvre($fic_grp);
	%g_memb_ok = %nul;
	for($g_i=0;$g_i<@g_groupes;$g_i++){
		($g_nom,$g_pw,$g_gid,$g_membres) = split(/:/,$g_groupes[$g_i]);
		next if ($g_gid < 10000);
		next if ($g_nom ne $_[1]);
		@g_memb_grp = split(/,/,$g_membres);
		foreach(@g_memb_grp){
		        $g_memb_ok{$_} = 1;
		}
		if($_[2] eq 'aj'){
		        $g_memb_ok{$_[0]} = 1;
		} elsif($_[2] eq 'sup') {
                                        delete $g_memb_ok{$_[0]};
                                }
		@g_memb_new = keys(%g_memb_ok);
		$g_membres_new = join(',',@g_memb_new);
		$g_groupes[$g_i] = join(':',($g_nom,$g_pw,$g_gid,$g_membres_new));
		last;
	}
                &maj_bdd($fic_grp,@g_groupes);
	return 1;
}

# retourne les membres d'un groupe (groupe,t|h); retourne un tableau (t) ou un hachage (h) des membres du groupe
sub memb_grp{
	@g_groupes = &ouvre($fic_grp);
	%g_memb_ok = %nul;
	foreach(@g_groupes){
		($g_nom,$g_pw,$g_gid,$g_membres) = split(/:/,$_);
		next if ($g_gid < 10000);
		next if ($g_nom ne $_[0]);
		@g_memb_grp = split(/,/,$g_membres);
		last;
	}
	if($_[1] eq 't'){
		return @g_memb_grp;
	} elsif($_[1] eq 'h') {
		foreach(@g_memb_grp){
			$g_memb_ok{$_} = 1;
		}
		return %g_memb_ok;
	}
}

# retourne les login des membres des groupes grp_xx avec (wresp)/sans (woresp) les responsables, ou seulement les responsables(respo) (wresp|woresp|respo); retourne hachage
sub memb_grps_{
	@g_groupes = &ouvre($fic_grp);
	@g_memb_ok = @nul;
	@g_memb_final = @nul;
	%g_memb_resp = %nul;
	foreach(@g_groupes){
		($g_nom,$g_pw,$g_gid,$g_membres) = split(/:/,$_);
		next if ($g_gid < 10000);
		if ($g_nom =~ /^grp_/){
			@g_memb_grp = split(/,/,$g_membres);
			push(@g_memb_ok,@g_memb_grp);
		} elsif (($g_gid == 10001) && ($_[0] eq 'respo')){
			@g_memb_grp = split(/,/,$g_membres);
			foreach(@g_memb_grp){
				$g_memb_resp{$_} = 1;
			}
		}
	}
                if ($_[0] =~ /^w/) {
                        foreach(@g_memb_ok){
                                $g_memb_final{$_} = 1 if (!$g_memb_resp{$_});
                        }
                } else {
                        %g_memb_final = %g_memb_resp;
                }
	return %g_memb_final;
}


# rajoute/enleve/modifie un utilisateur dans /etc/passwd (login,pw,comment,aj|sup|mod); modifie /etc/passwd ; retourne uid
sub mod_passwd{
        # determination uid
        @g_users = &ouvre($fic_usr);
        # classement
        @g_users = &classe('nc3',':',@g_users);
        if($_[3] eq 'aj'){
                ($g_login,$g_pw,$g_uid,@g_suite) = split(/:/,$g_users[@g_users-1]);
                # uid commencent a 10001 pour minal2
                if ($g_uid < 10001){
                        $g_uid_n = 10001;
                } else {
                        $g_uid_n = $g_uid +1;
                }
                # rajout /etc/passwd
                $g_ligne = join(':',($_[0],crypt($_[1],'A.'),$g_uid_n,'10002',$_[2],'/home/minal2/rep/'.$_[0],'/bin/bash'));
                push(@g_users,$g_ligne);
        } elsif ($_[3] eq 'sup'){
                $g_numero = -1;
                for ($g_i=0; $g_i<@g_users; $g_i++) {
                        ($g_login,$g_pw,$g_uid_n,@g_suite) = split(/:/,$g_users[$g_i]);
                        next if ($g_login ne $_[0]);
                        @g_users[$g_i...(@g_users-2)] = @g_users[$g_i+1...(@g_users-1)];
                        $supprime = pop(@g_users);
                        last;
                }
        } elsif ($_[3] eq 'mod'){
                $g_numero = -1;
                for ($g_i=0; $g_i<@g_users; $g_i++) {
                        ($g_login,$g_pw,$g_uid_n,@g_suite) = split(/:/,$g_users[$g_i]);
                        next if ($g_login ne $_[0]);
                        $g_ligne = join(':',($_[0],crypt($_[1],'A.'),$g_uid_n,'10002',$_[2],'/home/minal2/rep/'.$_[0],'/bin/bash'));
                        $g_users[$g_i] = $g_ligne;
                        last;
                }
        }
        &maj_bdd($fic_usr,@g_users);
        return $g_uid_n;
}

# rajoute/enleve un groupe dans /etc/group (nom,aj|sup); modifie /etc/group - cre ou supprime le repertoire du groupe; retourne gid (aj) ou @membres (sup)
sub mod_group{
        # determination gid
        @g_groupes = &ouvre($fic_grp);
        # classement
        @g_groupes = &classe('nc3',':',@g_groupes);
        if($_[1] eq 'aj'){
                ($g_nom,$g_pw,$g_gid,@g_suite) = split(/:/,$g_groupes[@g_groupes-1]);
                # gid commencent a 10003 pour minal2.1
                if ($g_gid < 10003){
                        $g_gid_n = 10003;
                } else {
                        $g_gid_n = $g_gid +1;
                }
                # rajout grp_
                $g_ligne = join(':',('grp_'.$_[0],'',$g_gid_n,'admin'));
                push(@g_groupes,$g_ligne);
                # rajout resp_
                $g_gid_n_resp = $g_gid_n + 1;
                $g_ligne = join(':',('resp_'.$_[0],'',$g_gid_n_resp,''));
                push(@g_groupes,$g_ligne);

                #--- rep grp
                $g_rep_grp = &untunt_fic('/home/minal2/rep/'.$_[0]);
                $g_gid_grp = &untunt_fic($g_gid_n);
                mkdir($g_rep_grp,0770);
                chown('10000',$g_gid_grp,$g_rep_grp);
                chmod(0770,$g_rep_grp);

        } elsif ($_[1] eq 'sup'){
                $g_numero = -1;
                for ($g_i=0; $g_i<@g_groupes; $g_i++) {
                        ($g_nom,$g_pw,$g_gid_n,$g_memb) = split(/:/,$g_groupes[$g_i]);
                        if ($g_nom eq 'grp_'.$_[0]) {
                                @ret_memb = split(/,/,$g_memb);
                                @g_groupes[$g_i...(@g_groupes-2)] = @g_groupes[$g_i+1...(@g_groupes-1)];
                                $supprime = pop(@g_groupes);
                                last;
                        }
                }
                for ($g_i=0; $g_i<@g_groupes; $g_i++) {
                        ($g_nom,$g_pw,$g_gid_n,$g_memb) = split(/:/,$g_groupes[$g_i]);
                        if ($g_nom eq 'resp_'.$_[0]){
                                @g_groupes[$g_i...(@g_groupes-2)] = @g_groupes[$g_i+1...(@g_groupes-1)];
                                $supprime = pop(@g_groupes);
                                last;
                        }
                }
                #--- rep grp
                $g_rep_grp = &untunt_fic('/home/minal2/rep/'.$_[0]);
                &del_rep($g_rep_grp);
        }
        &maj_bdd($fic_grp,@g_groupes);
        return $g_uid_n  if($_[1] eq 'aj');
        return @ret_memb  if($_[1] eq 'sup');
}

# cree un repertoire d'utilisateur (nom,uid); retourne 1
sub mk_dir{
        # perso
        $g_rep_perso = &untunt_fic('/home/minal2/rep/'.$_[0]);
        $g_uid_usr = &untunt_fic($_[1]);
        mkdir($g_rep_perso,0770);
        chown($g_uid_usr,'10001',$g_rep_perso);
        chmod(0770,$g_rep_perso);
        # profil
        $g_rep_profil = &untunt_fic('/home/minal2/profil/'.$_[0]);
        mkdir($g_rep_profil,0770);
        chown($g_uid_usr,'10000',$g_rep_profil);
        chmod(0770,$g_rep_profil);
        return 1;
}

# cree un repertoire de responsable (nom,uid); retourne 1
sub mk_dir2{
        # perso
        $g_rep_perso = &untunt_fic('/home/minal2/rep/'.$_[0]);
        $g_uid_usr = &untunt_fic($_[1]);
        mkdir($g_rep_perso,0770);
        chown($g_uid_usr,'10000',$g_rep_perso);
        chmod(0770,$g_rep_perso);
        # profil
        $g_rep_profil = &untunt_fic('/home/minal2/profil/'.$_[0]);
        mkdir($g_rep_profil,0770);
        chown($g_uid_usr,'10000',$g_rep_profil);
        chmod(0770,$g_rep_profil);
        return 1;
}

# liste les groupes
sub list_grp{
        @g_groupes = &ouvre($fic_grp);
        foreach $g_grp (@g_groupes){
                @g_detail = split(/:/,$g_grp);
                next  if (($g_detail[2] <= 10002) || ($g_detail[0] !~ /^resp_/));
	$g_detail[0] =~ s/^resp_//;
                push (@g_grp,$g_detail[0]);
        }
        return @g_grp;
}


# liste des groupes d'un responsable (login,t|h); retourne sous un tableau(t),soit un hachage (h)
sub grp_resp{
        @g_groupes = &ouvre($fic_grp);
        %g_resp_final = %nul;
        foreach $g_groupe (@g_groupes) {
                ($g_nom,$g_pwg,$g_gid,$g_users) = split(/:/,$g_groupe);
                next if (($g_gid < 10000) || ($g_nom !~ /^resp_/));
                @g_user = split(/,/,$g_users);
                foreach (@g_user){
                        next if ($_ ne $_[0]);
                        $g_nom =~ s/^resp_//;
                        $g_resp_final{$g_nom} = 1;
                        last;
                }
        }
        return %g_resp_final if ($_[1] eq 'h');
        return keys(%g_resp_final) if ($_[1] eq 't');
}

$minalsp = 'ok';







