#!/usr/bin/perl

##################################################################
# resp4.pl : modification pw/grp/nompren d'un utilisateur - Projet MINAL2.1
##################################################################

require './minal2.cfg';
require './minal2sp.pl';

#-- module cgi
use CGI qw/:standard/;
$| = 1;
$query = new CGI;

#-- entrees
foreach $key ($query->param()) {
	next if ($key =~ /^\s*$/);
	next if ($query->param($key) =~ /^\s*$/);
	next if ($query->param($key) =~ /<!--(.|\n)*-->/);
	$in{$key} = $query->param($key);
	$in{$key} =~ s/://g;
	$in{$key} =~ s/;//g;
	$in{$key} =~ s/\|//g;
}

#--- pas admin
if ($ENV{REMOTE_USER} eq 'admin'){
	$info .= '<br>Dsol, vous tes administrateur et vous avez votre propre <a href="./adm0.pl">page d\'administration</a><br>'."\n";
	&confirm($info);
}

#--- ctrl donnes
if (!($in{login})){
	&confirm_u("<center><hr><H1>Modification d\'un utilisateur</H1><hr></center><h2> Problme : aucun utilisateur choisi...</h2>");
}

#-- identification du responsable
@coor_resp = &trouve($ENV{REMOTE_USER},1,':',$fic_usr);

#-- controle existence dans fichier /etc/passwd et fic_tmp
($login,$pw,$uid,$gid,$nompren,$rep,$shell) = &trouve($in{login},1,':',$fic_usr);
if (!($login)){
	&confirm_u("<center><hr><H1>Modification d\'un utilisateur</H1><hr></center><h2> Problme : l\'utilisateur choisi ne figure plus dans la base...</h2>");
}

#--- groupes
@tab = &list_grp;
if (!(@tab)){
	&confirm_u("<center><hr><H1>Problme</H1><hr></center><h2>Aucun groupe d\'utilisateurs n\'est encore dfini...<br><br>Contactez votre responsable</h2>");
}

#--- liste des groupes du responsable
@group = &grp_resp( $ENV{REMOTE_USER},'t');
@group = &classe('ac1','x',@group);
$grp = join(', ',@group);

#--- controle javascript des champs obligatoires
$js  = '<SCRIPT LANGUAGE="JavaScript">'."\n";
$js .= '<!-- Debut script'."\n";
$js .= 'function verif() {'."\n";
$js .= 'if (!document.rens.nompren.value){'."\n";
$js .= '	alert("Vous devez saisir un nom")'."\n";
$js .= '} else {'."\n";
$js .= '	document.rens.submit()'."\n";
$js .= '}}'."\n";
$js .= '//  Fin script -->'."\n";
$js .= '</SCRIPT>'."\n";
$info .= $js."\n";
$info .= '<CENTER><hr><H1>Modification d\'un utilisateur</H1><hr></CENTER><BR>'."\n";

$info .= 'Responsable : <b>'.$coor_resp[4].'</b><br>'."\n";
if ($grp){
	$info .= 'Groupe : <b>'.$grp.'</b><br>&nbsp;<br>&nbsp;'."\n" if (@group == 1);
	$info .= 'Groupes : <b>'.$grp.'</b><br>&nbsp;<br>&nbsp;'."\n" if (@group > 1);
} else {
	$info  = '<CENTER><hr><H1>Inscription d\'un utilisateur</H1><hr></CENTER><BR>'."\n";
	$info .= 'Dsol, vous n\'tes actuellement responsable d\'aucun groupe d\'utilisateurs, veuillez contacter l\'administrateur du rseau.'."\n";
	&confirm_u($info);
}

$info .= '<H2>Vous pouvez modifier les informations suivantes :</H2>'."\n";
$info .= '<b>NB</b> : vous avez ici la possibilit de ne plus faire appartenir l\'utilisateur  aucun groupe<br><br>'."\n";

$info .= '<FORM METHOD=POST ACTION="'.$rep_cgi.'/resp5.pl" name="rens">'."\n";
$info .= '<CENTER><TABLE BORDER=0 WIDTH=450 CELLPADDING=5 CELLSPACING=5>'."\n";
$info .= '<TR><TD width=260>Modifier les Nom, Prnom :'."\n";
$info .= '</TD><TD><INPUT NAME="nompren" TYPE="TEXT" size=30 VALUE="'.$nompren.'"></TD></TR>'."\n";
$info .= '<TR><TD>Nom d\'utilisateur (non modifiable)&nbsp;:'."\n";
$info .= '</TD><TD>'.$login.'</TD></TR>'."\n";
$info .= '<TR><TD>Nouveau mot de passe :'."\n";
$info .= '<br><font size=2 color="#ff00ff">(entre 4 et 10 caractres, lettres ou chiffres sans espaces)</font>'."\n";
$info .= '</TD><TD><INPUT NAME="pw" TYPE="TEXT" size=20 maxlength=10 VALUE=""></TD></TR>'."\n";

$info .= '<TR><TD valign="top">Cochez  le ou les groupes auxquels cet utilisateur doit appartenir.<br>'."\n";
$info .= '<font size=2 color="#ddddff">(rappelons que le fait d\appartenir  un groupe donne accs au rpertoire commun du groupe)</font>'."\n";
$info .= '</TD><TD valign="top">'."\n";

foreach $nom (@group) {
	$info .= '<input type="checkbox" name="'.$nom.'" value="1"';
	%membre = &memb_grp('grp_'.$nom,'h');
	$info .= ' checked' if ($membre{$login});
	$info .= '>&nbsp;&nbsp;'.$nom.'<br>'."\n"
}

$info .= '</TD></TR>'."\n";
$info .= '<input type="hidden" name="login" value="'.$login.'">'."\n";
$info .= '<TR><TD colspan=2>&nbsp;</TD></TR>'."\n";
$info .= '<TR><TD colspan=2><CENTER><INPUT NAME="Envoi" TYPE="button" VALUE="Enregistrer les modifications" onClick="verif()"> '."\n";
$info .= '</CENTER></TD></TR>'."\n";
$info .= '</TABLE></CENTER></FORM><BR>'."\n";

#-----------affichage
&confirm_u("$info");
