#!/usr/bin/perl

##################################################################
# resp5.pl : modification d'un utilisateur - Projet MINAL2.1
##################################################################

require './minal2.cfg';
require './minal2sp.pl';

#-- module cgi
use CGI qw/:standard/;
$| = 1;
$query = new CGI;

#-- entrees
foreach $key ($query->param()) {
	next if ($key =~ /^\s*$/);
	next if ($query->param($key) =~ /^\s*$/);
	next if ($query->param($key) =~ /<!--(.|\n)*-->/);
	$in{$key} = $query->param($key);
	$in{$key} =~ s/://g;
	$in{$key} =~ s/;//g;
	$in{$key} =~ s/\|//g;
}

#--- pas admin
if ($ENV{REMOTE_USER} eq 'admin'){
	$info .= '<br>Dsol, vous tes administrateur et vous avez votre propre <a href="./adm0.pl">page d\'administration</a><br>'."\n";
	&confirm($info);
}

#--- controle champs
if (($in{pw})&&($in{pw} !~ /\w{4,10}/)){
	&confirm_u('<H1>Probl&#232;me</H1><H2>Le format pour le "Mot de passe" n\'est pas correct...</H2>');
} elsif (!$in{nompren}){
	&confirm_u('<H1>Probl&#232;me</H1><H2>Aucun nom saisi...</H2>');
}

#-- controle existence dans fichier /etc/passwd et /etc/group
($login,$pw,$uid,$gid,$nompren,$rep,$shell) = &trouve($in{login},1,':',$fic_usr);
if ( (!$login) && (&trouve($in{login},1,':',$fic_grp) == 0) ){
	$info .= '<CENTER><hr><H1>Modification d\'un utilisateur :</H1><hr></CENTER><BR>'."\n";
	$info .= '<h2>Problme</h2>Le nom d\'utilisateur  n\'est pas enregistr dans la base</b>...<BR>  '."\n";
	$info .= 'Vous pouvez l\'ajouter en cliquant <a href="'.$rep_cgi.'/resp1.pl">ici</a> <BR>'."\n";
	&confirm_u($info);
}

#--- modif /etc/passwd
if ( ($in{pw})||($in{nompren} ne $nompren) ){
	@tab = &ouvre($fic_usr);
	@tab = &classe('nc3',':',@tab);
	$numero = &trouve_ind($in{login},1,':',@tab);
	$pw_n = crypt($in{pw},'A.') if ($in{pw});
	$pw_n = $pw if (!$in{pw});
	$nompren_n = $in{nompren} if ($in{nompren});
	$nompren_n = $nompren if (!$in{nompren});
	$tab[$numero] = join(':',($login,$pw_n,$uid,$gid,$nompren_n,$rep,$shell));
	&maj_bdd($fic_usr,@tab);
}

#--- /etc/group
@groupes = &grp_resp($ENV{REMOTE_USER},'t');
foreach $group (@groupes){
	if($in{$group}){
		&mod_usr_grp($in{login},'grp_'.$group,'aj');
                } else {
		&mod_usr_grp($in{login},'grp_'.$group,'sup');
	}
}

#--- confirm
$info .= '<CENTER><hr><H1>Modification d\'un utilisateur</H1><hr></CENTER><BR>'."\n";
$info .= 'La modification  s\'est bien droule <BR>'."\n";
$info .= 'Modifier un <a href="./resp3.pl?desti=mod">autre utilisateur</a>'."\n";

&confirm_u($info);



