#!/usr/bin/perl

##################################################################
# resp6.pl : import d'un utilisateur disposant deja d'un acces- Projet MINAL2.1
##################################################################

require './minal2.cfg';
require './minal2sp.pl';

#-- module cgi
use CGI qw/:standard/;
$| = 1;
$query = new CGI;

#-- entrees
foreach $key ($query->param()) {
	next if ($key =~ /^\s*$/);
	next if ($query->param($key) =~ /^\s*$/);
	next if ($query->param($key) =~ /<!--(.|\n)*-->/);
	$in{$key} = $query->param($key);
	$in{$key} =~ s/://g;
	$in{$key} =~ s/;//g;
	$in{$key} =~ s/\|//g;
}

#--- pas admin
if ($ENV{REMOTE_USER} eq 'admin'){
	$info .= '<br>Dsol, vous tes administrateur et vous avez votre propre <a href="./adm0.pl">page d\'administration</a><br>'."\n";
	&confirm($info);
}

#--- controle champs
if (!$in{login}){
	&confirm_u('<H1>Probl&#232;me</H1><H2>Aucun utilisateur choisi...</H2>');
}

#-- controle existence dans fichier /etc/passwd et /etc/group
($login,$pw,$uid,$gid,$nompren,$rep,$shell) = &trouve($in{login},1,':',$fic_usr);
if ( (!$login) && (&trouve($in{login},1,':',$fic_grp) == 0) ){
	$info .= '<CENTER><hr><H1>Importer un utilisateur :</H1><hr></CENTER><BR>'."\n";
	$info .= '<h2>Problme</h2>Le nom d\'utilisateur  n\'est pas enregistr dans la base</b>...<BR>  '."\n";
	$info .= 'Vous pouvez l\'ajouter en cliquant <a href="'.$rep_cgi.'/resp1.pl">ici</a> <BR>'."\n";
	&confirm_u($info);
}

#--- groupes
@tab = &list_grp;
if (!(@tab)){
	&confirm_u("<center><hr><H1>Problme</H1><hr></center><h2>Aucun groupe d\'utilisateurs n\'est encore dfini...<br><br>Contactez votre responsable</h2>");
}

#--- liste des groupes du responsable
@group = &grp_resp($ENV{REMOTE_USER},'t');

#--- /etc/group
foreach $group (@group){
	if($in{$group}){
		&mod_usr_grp($in{login},'grp_'.$group,'aj');
                } else {
		&mod_usr_grp($in{login},'grp_'.$group,'sup');
	}
}


#--- confirm
$info .= '<CENTER><hr><H1>Importer un utilisateur</H1><hr></CENTER><BR>'."\n";
$info .= 'La modification s\'est bien droule <BR>'."\n";
$info .= 'Importer un <a href="./resp3.pl?desti=aj">autre utilisateur</a>'."\n";

&confirm_u($info);



