#!/usr/bin/perl

#########################################################
# usr2.pl : inscription des utilisateurs - Projet MINAL2.05
#########################################################

require './minal2.cfg';
require './minal2sp.pl';

#--- avert user
$in{dest} = 'user';

#-- module cgi
use CGI qw/:standard/;
$| = 1;
$query = new CGI;

#-- entrees
foreach $key ($query->param()) {
	next if ($key =~ /^\s*$/);
	next if ($query->param($key) =~ /^\s*$/);
	next if ($query->param($key) =~ /<!--(.|\n)*-->/);
	$in{$key} = $query->param($key);
	$in{$key} =~ s/://g;
	$in{$key} =~ s/;//g;
	$in{$key} =~ s/\|//g;
}

#--- controle champs
if ($in{login} !~ /^\w{4,10}$/){
	&confirm_user('<H1>Probl&#232;me</H1><H2>Le format pour le champ "Nom d\'utilisateur" n\'est pas correct...</H2>');
} elsif (($in{pw1} !~ /^\w{4,10}$/) || ($in{pw2} !~ /^\w{4,10}$/) ){
	&confirm_user('<H1>Probl&#232;me</H1><H2>Le format pour le champ "Mot de passe" n\'est pas correct...</H2>');
} elsif ($in{pw1}  ne $in{pw2}){
	&confirm_user('<H1>Probl&#232;me</H1><H2>Le "Mot de passe" est mal rpt...</H2>');
} elsif (!$in{nompren}){
	&confirm_user('<H1>Probl&#232;me</H1><H2>Aucun nom saisi...</H2>');
} elsif (!$in{grp}){
	&confirm_user('<H1>Probl&#232;me</H1><H2>Aucun groupe choisi...</H2>');
} elsif (($in{login} =~ /^grp_/)||($in{login} =~ /^resp_/)){
	&confirm_user('<H1>Probl&#232;me</H1><H2>Le format pour le champ "Nom d\'utilisateur" n\'est pas correct...(pas de "resp_" ni de "grp_")</H2>');
}

#--- fichier temporaire d'inscript
$fic_tmp = &untunt_fic($fic_tempo);
&makif($fic_tmp);

#-- controle existence dans fichier /etc/passwd et fic_tmp et /etc/group
if ((&trouve($in{login},1,':',$fic_usr) != 0)||(&trouve($in{login},3,'\|',$fic_tmp) != 0)||(&trouve($in{login},1,':',$fic_grp) != 0)){
	$info .= '<CENTER><hr><H1>Inscription  un groupe d\'utilisateurs :</H1><hr></CENTER><BR>'."\n";
	$info .= '<h2>Problme</h2>Ce nom d\'utilisateur est dj enregistr</b>...<BR>  '."\n";
	$info .= '<a href="javascript:history.back()">Choisissez-en</a> un autre... <BR>'."\n";
	&confirm_user($info);
}
	
#--- ajout ligne
@users = &ouvre($fic_tmp);
$ligne = join('|',($in{grp},$in{nompren},$in{login},$in{pw1}));
push(@users,$ligne);
&maj_bdd($fic_tmp,@users);

#--- confirm
$info .= '<CENTER><hr><H1>Inscription  un groupe d\'utilisateurs :</H1><hr></CENTER><BR>'."\n";
$info .= 'L`inscription s\'est bien droule dans le groupe "<b>'.$in{grp}.'</b>"<BR>'."\n";
$info .= 'Vous devez attendre que le responsable de ce groupe d\'utilisateurs valide votre inscription pour avoir accs au rseau. <BR>'."\n";

&confirm_user($info);
