#!/usr/bin/perl

##################################################################
# adm14.pl : affichage des informations d'un groupe - Projet MINAL2.1
##################################################################

require './minal2.cfg';
require './minal2sp.pl';

#--- avert admin
$in{dest} = 'a';

#-- module cgi
use CGI qw/:standard/;
$| = 1;
$query = new CGI;

#-- entrees
foreach $key ($query->param()) {
	next if ($key =~ /^\s*$/);
	next if ($query->param($key) =~ /^\s*$/);
	next if ($query->param($key) =~ /<!--(.|\n)*-->/);
	$in{$key} = $query->param($key);
	$in{$key} =~ s/://g;
	$in{$key} =~ s/;//g;
	$in{$key} =~ s/\|//g;
}

#--- controle champs
if (!$in{grp}){
	&confirm('<H1>Probl&#232;me</H1><H2>Aucun groupe choisi...</H2>');
}

#--- groupes
@tab = &list_grp;
if (!(@tab)){
	&confirm("<center><hr><H1>Problme</H1><hr></center><h2>Aucun groupe d\'utilisateurs n\'est encore dfini...<br><br>Contactez votre responsable</h2>");
}

#--- recup des login des usr du groupes grp_
%member = &memb_grp('grp_'.$in{grp},'h');
%resp  = &memb_grp('resp_'.$in{grp},'h');
%respons  = &memb_grp('resp','h');


#--- affichage
$info .= '<CENTER><hr><H1>Affichage des donnes d\'un groupe d\'utilisateurs</H1><hr></CENTER><BR>'."\n";
#--- utilisateurs appartenant a un groupe
 if ($in{grp} ne 'nogrp'){
	$info .= '<br><h2>Groupe '.$in{grp}.'</h2><br><br>'."\n";
	$info .= '<b><h3>Responsables</b></h3>'."\n";
	$info .= '<CENTER><table width=590 border=0 cellpadding=5>'."\n";
	$info .= '<tr><td width=260><b>Nom, Prnom</b></td><td width=165><b>Caractristiques</b></td><td width=165><b>Suppression</b></td></tr>'."\n";
	$info .= '<TR><TD colspan=3><hr></TD></TR>'."\n";
	foreach(keys(%resp)){
		($login,$pw,$uid,$gid,$nompren,$rep,$shell) = &trouve($_,1,':',$fic_usr);
		next if (!$login);
		$info .= '<tr><td>'.$nompren.' ('.$login.')'.'</td>';
		$info .= '<td><a href="'.$rep_cgi.'/adm4.pl?login='.$login.'">Modifier</a></td>'."\n";
		$info .= '<td><a href="'.$rep_cgi.'/adm20.pl?desti=sup&login='.$login.'">Supprimer</a></td></tr>';
	}
	$info .= '</table></center><br><br>'."\n";
#--- utilisateurs n'appartenant a aucun groupe
} else {
	$info .= '<br><h2>Utilisateurs n\'appartenant  aucun groupe</h2><br><br>'."\n";
	%memb_1_grp = &memb_grps_('woresp');
}

$info .= '<h3><b>Membres</b></h3>'."\n";
$info .= '<CENTER><table width=590 border=0  cellpadding=5>'."\n";
$info .= '<tr><td width=260><b>Nom, Prnom</b></td><td width=165><b>Caractristiques</b></td><td width=165><b>Suppression</b></td></tr>'."\n";
$info .= '<TR><TD colspan=3><hr></TD></TR>'."\n";

# tous les membres
@membres_all = &ouvre($fic_usr);
@membres_all = &classe('ac5',':',@membres_all);
foreach(@membres_all){
	($login,$pw,$uid,$gid,$nompren,$rep,$shell) = split(':',$_);
	next if ($uid < 10001);
	next if (($memb_1_grp{$login} || $respons{$login})&& ($in{grp} eq 'nogrp'));
	next if (! $member{$login} && ($in{grp} ne 'nogrp'));
	# responsable de ce groupe
	if ($resp{$login}){
		$info .= '<tr><td><font color="#ddddff"><i>'.$nompren.'  : responsable de ce groupe</i></font>'.'</td>';
		$info .= '<td><a href="'.$rep_cgi.'/adm4.pl?login='.$login.'"><i>Modifier</i></a></td>';
		$info .= '<td><a href="'.$rep_cgi.'/adm20.pl?desti=sup&login='.$login.'"><i>Supprimer</i></a></td></tr>'."\n";
	# responsable
	} elsif ($respons{$login}){
		$info .= '<tr><td><font color="#ddddff"><i>'.$nompren.'  : responsable</i></font>'.'</td>';
		$info .= '<td><a href="'.$rep_cgi.'/adm4.pl?login='.$login.'"><i>Modifier</i></a></td>';
		$info .= '<td><a href="'.$rep_cgi.'/adm20.pl?desti=sup&login='.$login.'"><i>Supprimer</i></a></td></tr>'."\n";
 	# c'est un utilisateur
 	} else {
	        $info .= '<tr><td>'.$nompren.' ('.$login.')'.'</td>';
		$info .= '<td><a href="'.$rep_cgi.'/adm7.pl?login='.$login.'">Modifier</a></td>';
		$info .= '<td><a href="'.$rep_cgi.'/adm3.pl?desti=sup&login='.$login.'">Supprimer</a></td></tr>'."\n";
	}
}
$info .= '</table></center><br><br><br>'."\n";

&confirm($info);









