#!/usr/bin/perl

##################################################################
# adm18.pl : validation d'utilisateurs en attente - Projet MINAL2.1
##################################################################

require './minal2.cfg';
require './minal2sp.pl';

#--- message admin
$in{dest} = 'a';

#-- module cgi
use CGI qw/:standard/;
$| = 1;
$query = new CGI;

#-- entrees
foreach $key ($query->param()) {
	next if ($key =~ /^\s*$/);
	next if ($query->param($key) =~ /^\s*$/);
	next if ($query->param($key) =~ /<!--(.|\n)*-->/);
	$in{$key} = $query->param($key);
	$in{$key} =~ s/://g;
	$in{$key} =~ s/;//g;
	$in{$key} =~ s/\|//g;
}


#--- groupes
@tab = &list_grp;
if (!@tab){
	&avert('a',"<center><hr><H1>Problme</H1><hr></center><h2>Aucun groupe d\'utilisateurs n\'est encore dfini...<br>Cliquez <a href=\"./adm9.pl\">ici</a> pour en rajouter un</h2>");
}

#--- fichier temporaire : tri
@tab = &ouvre($fic_tempo);
foreach $util (@tab){
	($nom_grp,$nompren,$login,$pw) = split(/\|/,$util);
	if ($in{$login} !~ /\d/){
		# pas statu sur son sort
		push(@rest,$util);
		push(@non_stat,$util);
	} elsif ($in{$login} == '0'){
		# refus
		push(@usr_non,$util);
	} elsif ((&trouve($login,1,':',$fic_usr) != 0)||(&trouve($login,1,':',$fic_grp) != 0)){
		# valid mais refus : deja present
		push(@rebut1,$util);
	} elsif (($login !~ /\w{4,10}/)||($pw !~ /\w{4,10}/)||($login =~ /^resp_/)||($login =~ /^grp_/)){
		# valid mais refus : pas bon login ou pw
		push(@rebut2,$util);
	} else {
		# usr ok
		push(@usr_oui,$util);
	}
}

#--- /etc/passwd, rep perso, rep profil
@usr_oui2 = @usr_oui;
foreach(@usr_oui){
	($nom_grp,$nompren,$login,$pw) = split(/\|/,$_);
	$uid = &mod_passwd($login,$pw,$nompren,'aj');
        	&mk_dir($login,$uid);
       	&mod_usr_grp($login,'grp_'.$nom_grp,'aj');
}

#--- maj
&maj_bdd($fic_tempo,@rest) if (@rest < @tab);

#--- confirm
$info .= '<CENTER><hr><H1>Validation des utilisateurs en attente</H1><hr></CENTER><BR>'."\n";
$info .= 'Responsable : <b>Administrateur</b><br><br><br>'."\n";
#--- valide
$info .= '<br><h3>'.$bouton.' Utilisateur(s) valid(s): '.@usr_oui.'</h3>'."\n";
if (@usr_oui2){
	$info .= '<ul>'."\n";
	foreach(@usr_oui2){
		($nom_grp,$nompren,$login,$pw) = split(/\|/,$_);
		$info .= '<li> '.$nompren.', groupe '.$nom_grp.' (<a href="'.$rep_cgi.'/adm7.pl?login='.$login.'">modifier</a>)'."\n";
	}
	$info .= '</ul>'."\n";
}
#--- non valid
$info .= '<br><h3>'.$bouton.' Utilisateur(s) supprim(s): '.@usr_non.'</h3>'."\n";
if (@usr_non){
	$info .= '<ul>'."\n";
	foreach(@usr_non){
		($nom_grp,$nompren,$login,$pw) = split(/\|/,$_);
		$info .= '<li> '.$nompren.', groupe '.$nom_grp."\n";
	}
	$info .= '</ul>'."\n";
}
#--- non statu
$info .= '<br><h3>'.$bouton.' Utilisateur(s) en attente de validation : '.@non_stat.'</h3>'."\n";
if (@non_stat){
	$info .= '<ul>'."\n";
	foreach(@non_stat){
		($nom_grp,$nompren,$login,$pw) = split(/\|/,$_);
		$info .= '<li> '.$nompren.', groupe '.$nom_grp."\n";
	}
	$info .= '</ul>'."\n";
}
#--- non conforme1
if (@rebut1){
	$info .= '<br><h3>'.$bouton.' Accs refus : nom d\'utilisateur dj prsent dans la base: '.@rebut1.'</h3>'."\n";
	$info .= '<ul>'."\n";
	foreach(@rebut1){
		s/ //g;
		($nom_grp,$nompren,$login,$pw) = split(/\|/,$_);
		$info .= '<li> '.$nompren.', groupe '.$nom_grp.' (<a href="'.$rep_cgi.'/adm1.pl?login='.$login.'&nompren='.$nompren.'&pw='.$pw.'">modifier</a>)'."\n";
	}
	$info .= '</ul>'."\n";
}	
#--- non conforme2
if (@rebut2){
	$info .= '<br><h3>'.$bouton.' Accs refus : nom d\'utilisateur ou mot de passe non valide : '.@rebut2.'</h3>'."\n";
	$info .= '<ul>'."\n";
	foreach(@rebut2){
		s/ //g;
		($nom_grp,$nompren,$login,$pw) = split(/\|/,$_);
		$info .= '<li> '.$nompren.', groupe '.$nom_grp.' (<a href="'.$rep_cgi.'/adm1.pl?login='.$login.'&nompren='.$nompren.'&pw='.$pw.'">modifier</a>)'."\n";
	}
	$info .= '</ul>'."\n";
}	
		
&avert('a',$info);




