#!/usr/bin/perl

##################################################################
# adm2.pl : inscription directe d'un utilisateur - Projet MINAL2.1
##################################################################

require './minal2.cfg';
require './minal2sp.pl';

#--- avert admin
$in{dest} = 'a';

#-- module cgi
use CGI qw/:standard/;
$| = 1;
$query = new CGI;

#-- entrees
foreach $key ($query->param()) {
	next if ($key =~ /^\s*$/);
	next if ($query->param($key) =~ /^\s*$/);
	next if ($query->param($key) =~ /<!--(.|\n)*-->/);
	$in{$key} = $query->param($key);
	$in{$key} =~ s/://g;
	$in{$key} =~ s/;//g;
	$in{$key} =~ s/\|//g;
}


#--- controle champs
if ($in{login} !~ /^\w{4,10}$/){
	&confirm('<H1>Probl&#232;me</H1><H2>Le format pour le champ "Nom d\'utilisateur" n\'est pas correct...</H2>');
} elsif ($in{pw} !~ /^\w{4,10}$/){
	&confirm('<H1>Probl&#232;me</H1><H2>Le format pour le champ "Mot de passe" n\'est pas correct...</H2>');
} elsif (!$in{nompren}){
	&confirm('<H1>Probl&#232;me</H1><H2>Aucun nom saisi...</H2>');
} elsif (($in{login} =~ /^resp_/)||($in{login} =~ /^grp_/)||($in{login} =~ /^document$/)){
	&confirm('<H1>Probl&#232;me</H1><H2>Le "Nom d\'utilisateur" n\'est pas correct...(pas de "resp_" ni de "grp_" ni de "document")</H2>');
}

#-- controle existence dans fichier /etc/passwd et /etc/group
if ((&trouve($in{login},1,':',$fic_usr) != 0)||(&trouve($in{login},1,':',$fic_grp) != 0)){
	$info .= '<CENTER><hr><H1>Inscription d\'un utilisateur :</H1><hr></CENTER><BR>'."\n";
	$info .= '<h2>Problme</h2>Ce nom d\'utilisateur est dj utilis</b>...<BR>  '."\n";
	$info .= '<a href="javascript:history.back()">Choisissez-en</a> un autre... <BR>'."\n";
	&confirm($info);
}
	

#--- /etc/passwd
$uid = &mod_passwd($in{login},$in{pw},$in{nompren},'aj');

#--- rep
&mk_dir($in{login},$uid);

#--- /etc/group
@groupes = &list_grp;
foreach $group (@groupes){
	if($in{$group}){
		&mod_usr_grp($in{login},'grp_'.$group,'aj');
                } else {
		&mod_usr_grp($in{login},'grp_'.$group,'sup');
	}
}


#--- confirm
$info .= '<CENTER><hr><H1>Inscription d\'un utilisateur</H1><hr></CENTER><BR>'."\n";
$info .= 'L\'inscription s\'est bien droule <BR>'."\n";
$info .= 'Rajouter un <a href="'.$rep_cgi.'/adm1.pl">nouvel utilisateur</a><BR>'."\n";

&confirm($info);
