#!/usr/bin/perl

#######################################################################################
# adm5.pl : modification de responsabilit de groupe d'un utilisateur - Projet MINAL2.1
#######################################################################################

require './minal2.cfg';
require './minal2sp.pl';

#--- avert admin
$in{dest} = 'a';

#-- module cgi
use CGI qw/:standard/;
$| = 1;
$query = new CGI;

#-- entrees
foreach $key ($query->param()) {
	next if ($key =~ /^\s*$/);
	next if ($query->param($key) =~ /^\s*$/);
	next if ($query->param($key) =~ /<!--(.|\n)*-->/);
	$in{$key} = $query->param($key);
	$in{$key} =~ s/://g;
	$in{$key} =~ s/;//g;
	$in{$key} =~ s/\|//g;
}

#--- controle champs
if (!$in{login}){
	&confirm('<H1>Probl&#232;me</H1><H2>Aucun utilisateur choisi...</H2>');
} elsif (($in{pw})&&($in{pw} !~ /\w{4,10}/)){
	&confirm('<H1>Probl&#232;me</H1><H2>Le format pour le "Mot de passe" n\'est pas correct...</H2>');
} elsif (!$in{nompren}){
	&confirm('<H1>Probl&#232;me</H1><H2>Aucun nom saisi...</H2>');
}

#--- identification responsable
($login,$pw,$uid,$gid,$nompren,$rep,$shell) = &trouve($in{login},1,':',$fic_usr);

#--- groupes
@tab = &list_grp;
if (!(@tab)){
	&confirm("<center><hr><H1>Problme</H1><hr></center><h2>Aucun groupe d\'utilisateurs n\'est encore dfini...<br><br>Contactez votre responsable</h2>");
}
foreach $group (@tab){
	if($in{'resp_'.$group}){
		&mod_usr_grp($in{login},'resp_'.$group,'aj');
	} else {
		&mod_usr_grp($in{login},'resp_'.$group,'sup');
	}
	if($in{'grp_'.$group}){
		&mod_usr_grp($in{login},'grp_'.$group,'aj');
	} else {
		&mod_usr_grp($in{login},'grp_'.$group,'sup');
	}
}

#--- /etc/passwd
if ($in{pw} || ($in{nompren} ne $nompren)) {
	$uid = &mod_passwd($in{login},$in{pw},$in{nompren},'mod');
}


#--- fichier usr_file
if ($in{pw}){
        @tab = &ouvre($acc_usr);
        $numero = -1;
        $modif = 0;
        for($i=0;$i<@tab;$i++){
                ($nom,$pw) = split(/:/,$tab[$i]);
                next if ($nom ne $in{login});
                $numero = $i;
                last;
        }
        if ($numero != -1){
                @tab[$numero] = join(':',($in{login},crypt($in{pw},"A.")));
        } else {
                @tab[@tab] = join(':',($in{login},crypt($in{pw},"A.")));
        }
        &maj_bdd($acc_usr,@tab);
}



#--- fichier grp_file
@tab = &ouvre($acc_grp);
for($i=0;$i<@tab;$i++){
	($nom_groupe,$membres) = split(/:/,$tab[$i]);
	next if ($nom_groupe ne 'resp');
	$membres =~ s/^ //;
	@membres_resp = split(/ /,$membres);
	foreach(@membres_resp){
		$present = 1 if ($_ eq $in{login})
	}
	if (!$present){
		push(@membres_resp,$in{login});
		$membres = join(' ',@membres_resp);
	}
	$membres =~ s/^/ /;
	$tab[$i] = join(':',($nom_groupe,$membres));
}
&maj_bdd($acc_grp,@tab);



#--- message confirmation
$info .= '<CENTER><hr><H1>Modification d\'un responsable</H1><hr></CENTER><BR>'."\n";
$info .= 'Le changement  s\'est bien droul.<br>'."\n";
$info .= 'Modifier un <a href="./adm20.pl?desti=mod">autre responsable</a>'."\n";

&confirm($info);









