#!/usr/bin/perl

##################################################################
# resp1.pl : inscription directe d'un utilisateur - Projet MINAL2.1
##################################################################

require './minal2.cfg';
require './minal2sp.pl';

#-- module cgi
use CGI qw/:standard/;
$| = 1;
$query = new CGI;

#-- entrees
foreach $key ($query->param()) {
	next if ($key =~ /^\s*$/);
	next if ($query->param($key) =~ /^\s*$/);
	next if ($query->param($key) =~ /<!--(.|\n)*-->/);
	$in{$key} = $query->param($key);
	$in{$key} =~ s/://g;
	$in{$key} =~ s/;//g;
	$in{$key} =~ s/\|//g;
	$in{$key} =~ s// /g; #traitement spec pour ce script
}

#--- pas admin
if ($ENV{REMOTE_USER} eq 'admin'){
	$info .= '<br>Dsol, vous tes administrateur et vous avez votre propre <a href="./adm0.pl">page d\'administration</a><br>'."\n";
	&confirm($info);
}

#-- identification du responsable
($login,$pw,$uid,$gid,$nompren,$rep,$shell) = &trouve($ENV{REMOTE_USER},1,':',$fic_usr);

#--- groupes
@tab =&list_grp;
@tab = &classe('ac1','x',@tab);
if (!(@tab)){
	&confirm_u("<center><hr><H1>Problme</H1><hr></center><h2>Aucun groupe d\'utilisateurs n\'est encore dfini...<br><br>Contactez votre responsable</h2>");
}

#--- liste des groupes du responsable
@group = &grp_resp($login,'t');
@group = &classe('ac1','x',@group);
foreach(@group){
        $checkbox_groupes .= '<input type="checkbox" name="'.$_.'" VALUE="1"> '.$_.'<br>'."\n";
        push (@js_group,'(!document.rens.'.$_.'.checked)');
}
$js_grp = join(' && ',@js_group);
$grp = join(', ',@group);


#--- controle javascript des champs obligatoires
$js  = '<SCRIPT LANGUAGE="JavaScript">'."\n";
$js .= '<!-- Debut script'."\n";
$js .= 'function verif() {'."\n";
$js .= 'if (!document.rens.nompren.value){'."\n";
$js .= '	alert("Vous devez saisir un nom")'."\n";
$js .= '} else if (!document.rens.login.value){'."\n";
$js .= '	alert("Vous devez saisir un nom d\'utilisateur")'."\n";
$js .= '} else if (!document.rens.pw.value){'."\n";
$js .= '	alert("Vous devez saisir un mot de passe")'."\n";
$js .= '} else if ('.$js_grp.'){'."\n";
$js .= '	alert("Vous devez choisir un groupe d\'utilisateurs")'."\n";
$js .= '} else {'."\n";
$js .= '	document.rens.submit()'."\n";
$js .= '}}'."\n";
$js .= '//  Fin script -->'."\n";
$js .= '</SCRIPT>'."\n";
$info .= $js."\n";
$info .= '<CENTER><hr><H1>Inscription d\'un utilisateur</H1><hr></CENTER><BR>'."\n";

$info .= 'Responsable : <b>'.$nompren.'</b><br>'."\n";
if ($grp){
	$info .= 'Groupe : <b>'.$grp.'</b><br>&nbsp;<br>&nbsp;'."\n" if (@group == 1);
	$info .= 'Groupes : <b>'.$grp.'</b><br>&nbsp;<br>&nbsp;'."\n" if (@group > 1);
} else {
	$info  = '<CENTER><hr><H1>Inscription d\'un utilisateur</H1><hr></CENTER><BR>'."\n";
	$info .= 'Dsol, vous n\'tes actuellement responsable d\'aucun groupe d\'utilisateurs, veuillez contacter l\'administrateur du rseau.'."\n";
	&confirm_u($info);
}


$info .= '<H2>Saisissez tous les renseignements suivants :</H2>'."\n";
$info .= '<FORM METHOD=POST ACTION="'.$rep_cgi.'/resp2.pl" name="rens">'."\n";
$info .= '<CENTER><TABLE BORDER=0 WIDTH=450 CELLPADDING=5 CELLSPACING=5>'."\n";
$info .= '<TR><TD width=260>Nom, Prnom :'."\n";
$info .= '</TD><TD><INPUT NAME="nompren" TYPE="TEXT" size=30 VALUE="'.$in{nompren}.'"></TD></TR>'."\n";
$info .= '<TR><TD>Indiquez un nom d\'utilisateur :'."\n";
$info .= '<br><font size=2 color="#ff00ff">(entre 4 et 10 caractres, lettres ou chiffres sans espaces)</font>'."\n";
$info .= '</TD><TD><INPUT NAME="login" TYPE="TEXT" size=20 maxlength=10 VALUE="'.$in{login}.'"></TD></TR>'."\n";
$info .= '<TR><TD>Indiquez un mot de passe :'."\n";
$info .= '<br><font size=2 color="#ff00ff">(entre 4 et 10 caractres, lettres ou chiffres sans espaces)</font>'."\n";
$info .= '</TD><TD><INPUT NAME="pw" TYPE="TEXT" size=20 maxlength=10 VALUE="'.$in{pw}.'"></TD></TR>'."\n";
$info .= '<TR><TD colspan=2>&nbsp;</TD></TR>'."\n";

$info .= '<TR><TD valign="top">Cochez  le ou les groupes auxquels cet utilisateur doit appartenir&nbsp;:'."\n";
$info .= '<br><font size=2 color="#ddddff">(rappelons que le fait d\appartenir  un groupe donne accs au rpertoire commun du groupe)</font>'."\n";
$info .= '</TD><TD valign="top">'."\n";
$info .= $checkbox_groupes;
$info .= '</TD></TR>'."\n";

$info .= '<TR><TD colspan=2>&nbsp;</TD></TR>'."\n";
$info .= '<TR><TD colspan=2><CENTER><INPUT NAME="Envoi" TYPE="button" VALUE="Inscription" onClick="verif()"> '."\n";
$info .= '<INPUT NAME="raz" TYPE="RESET" VALUE="Effacer"></CENTER></TD></TR>'."\n";
$info .= '</TABLE></CENTER></FORM><BR>'."\n";


#--- affichage
&confirm_u($info);
