#!/usr/bin/perl

##################################################################
# resp3.pl : menu multi-destination (ajout, modif utilisateur)- Projet MINAL2.1
##################################################################

require './minal2.cfg';
require './minal2sp.pl';

#-- module cgi
use CGI qw/:standard/;
$| = 1;
$query = new CGI;

#-- entrees
foreach $key ($query->param()) {
	next if ($key =~ /^\s*$/);
	next if ($query->param($key) =~ /^\s*$/);
	next if ($query->param($key) =~ /<!--(.|\n)*-->/);
	$in{$key} = $query->param($key);
	$in{$key} =~ s/://g;
	$in{$key} =~ s/;//g;
	$in{$key} =~ s/\|//g;
}

#--- pas admin
if ($ENV{REMOTE_USER} eq 'admin'){
	$info .= '<br>Dsol, vous tes administrateur et vous avez votre propre <a href="./adm0.pl">page d\'administration</a><br>'."\n";
	&confirm($info);
}

#-- identification du responsable
($login,$pw,$uid,$gid,$nompren,$rep,$shell) = &trouve($ENV{REMOTE_USER},1,':',$fic_usr);

#--- controle champs
if (!$in{desti}){
	&confirm_u('<H1>Probl&#232;me</H1><H2>Aucune destination choisie...</H2>');
}

#--- groupes
@tab = &list_grp;
if (!(@tab)){
	&confirm_u("<center><hr><H1>Problme</H1><hr></center><h2>Aucun groupe d\'utilisateurs n\'est encore dfini...<br><br>Contactez votre responsable</h2>");
}
#--- liste des groupes du responsable
@group = &grp_resp($login,'t');
@group = &classe('ac1','x',@group);
$grp = join(', ',@group);

#--- liste des groupes case a cocher
foreach (@group) {
	$checkbox_groupes .= '<input type="checkbox" name="'.$_.'" VALUE="1"> '.$_.'<br>'."\n";
	push (@js_group,'(!document.rens.'.$_.'.checked)');
}
$js_grp = join(' && ',@js_group);
$grp = join(', ',@group);

#--- liste des utilisateurs appartenant aux groupes du responsable 
foreach $the_grp (@group){
	%membres_grp = &memb_grp('grp_'.$the_grp,'h');
	%memb_du_resp = (%memb_du_resp,%membres_grp);
}

#--- liste de tous les  responsables
%all_resp = &memb_grp('resp','h');

#--- controle javascript des champs obligatoires
$js  = '<SCRIPT LANGUAGE="JavaScript">'."\n";
$js .= '<!-- Debut script'."\n";
$js .= 'function verif() {'."\n";
$js .= 'if (!document.rens.login.options[document.rens.login.selectedIndex].value){'."\n";
$js .= '	alert("Vous devez choisir un utilisateur")'."\n";
if ($in{desti} eq 'aj'){
	$js .= '} else if ('.$js_grp.'){'."\n";
	$js .= '	alert("Vous devez choisir un groupe d\'utilisateurs")'."\n";
}
$js .= '} else {'."\n";
$js .= '	document.rens.submit()'."\n";
$js .= '}}'."\n";
$js .= '//  Fin script -->'."\n";
$js .= '</SCRIPT>'."\n";
$info .= $js."\n";

$info2 .= 'Responsable : <b>'.$nompren.'</b><br>'."\n";
if ($grp){
	$info2 .= 'Groupe : <b>'.$grp.'</b><br>&nbsp;<br>&nbsp;'."\n" if (@group == 1);
	$info2 .= 'Groupes : <b>'.$grp.'</b><br>&nbsp;<br>&nbsp;'."\n" if (@group > 1);
} else {
	$info  = '<CENTER><hr><H1>Inscription d\'un utilisateur</H1><hr></CENTER><BR>'."\n";
	$info .= 'Dsol, vous n\'tes actuellement responsable d\'aucun groupe d\'utilisateurs, veuillez contacter l\'administrateur du rseau.'."\n";
	&confirm_u($info);
}

#--- affichage selon dest
if ($in{desti} eq 'aj'){
	$info .= '<CENTER><hr><H1>Rajouter un utilisateur</H1><hr></CENTER><BR>'."\n";
	$info .= $info2."\n";
	$info .= '<br>Voici la liste des utilisateurs disposant dj d\'un compte (login + mot de passe), et n\'tant  inscrit dans aucun des groupes dont vous avez la responsabilit. '."\n";
	$info .= 'Vous pouvez effectuer l\'importation ici&nbsp;:<BR><br>'."\n";
	$info .= '<FORM METHOD=POST ACTION="'.$rep_cgi.'/resp6.pl" name="rens">'."\n";
} elsif ($in{desti} eq 'mod'){
	$info .= '<CENTER><hr><H1>Modification des donnes d\'un utilisateur</H1><hr></CENTER><BR>'."\n";
	$info .= $info2."\n";
	$info .= '<br>Un utilisateur fait  partie  d\'un des groupes dont vous avez la responsabilit. Vous souhaitez modifier ses donnes.'."\n";
	$info .= 'Vous pouvez le faire  ici&nbsp;:<BR><br>'."\n";
	$info .= '<FORM METHOD=POST ACTION="'.$rep_cgi.'/resp4.pl" name="rens">'."\n";
}


#--- suite commune
$info .= '<CENTER><TABLE BORDER=0 WIDTH=450 CELLPADDING=5 CELLSPACING=5>'."\n";
$info .= '<TR><TD>Slectionnez l\'utilisateur&nbsp;:</TD>'."\n";

$info .= '<TD><SELECT NAME="login" SIZE=1>'."\n";
$info .= '<OPTION VALUE="">'."\n";

@users = &ouvre($fic_usr);
@users = &classe('ac5',':',@users);
foreach(@users){
	($login,$pw,$uid,$gid,$nompren,$rep,$shell) = split(/:/,$_);
	next if ($uid <= 10000);
	next if ($login  eq 'visiteur');
	next if ( (!$memb_du_resp{$login}|| $all_resp{$login}) && ($in{desti} eq 'mod') );
	next if ( ($memb_du_resp{$login} || $all_resp{$login}) && ($in{desti} eq 'aj') );
	next if (!$nompren);
	next if ($rep !~ /^\/home\/minal2\/rep/);
	$valide = 1;
	$info .= '<OPTION VALUE="'.$login.'">'.$nompren.' ('.$login.')'."\n";
}

#--- controle usr present
if (!$valide && ($in{desti} eq 'mod')){
	&confirm_u("<center><hr><H1>Information</H1><hr></center><br>Aucun utilisateur n\'est encore inscrit dans le ou les groupes dont vous tes responsables<br>Cette rubrique vous permet de modifier les membres existants... ");
} elsif (!$valide && ($in{desti} eq 'aj')){
	&confirm_u("<center><hr><H1>Importer un utilisateur</H1><hr></center><br>Tous les utilisateurs sont dj inscrits dans le ou les groupes dont vous tes responsables<br>Il n\'est pas possible d\'en importer actuellement...");
}

$info .= '</SELECT></TD></TR>'."\n";

if ($in{desti} eq 'aj'){
	$info .= '<TR><TD valign="top">Cochez le ou les groupes au(x)quel(s) cet utilisateur doit appartenir&nbsp;:'."\n";
	$info .= '<br><font size=2 color="#ddddff">(rappelons que le fait d\importer un utilisateur vous offre la possibilit de le grer et lui donne accs au rpertoire commun du ou des groupe(s))</font>'."\n";
	$info .= '</TD><TD valign="top">'."\n";
	$info .= $checkbox_groupes;
	$info .= '</TD></TR>'."\n";
	$info .= '<TR><TD colspan=2>&nbsp;</TD></TR>'."\n";
	$info .= '<TR><TD colspan=2 align="CENTER"><INPUT NAME="Envoi" TYPE="button" VALUE="Ajouter cet utilisateur au(x) groupe(s) slectionn(s)" onClick="verif()"> '."\n";
} elsif ($in{desti} eq 'mod'){
	$info .= '<TR><TD colspan=2>&nbsp;</TD></TR>'."\n";
	$info .= '<TR><TD colspan=2 align="CENTER"><INPUT NAME="Envoi" TYPE="button" VALUE="Modifier cet utilisateur" onClick="verif()"> '."\n";
}

$info .= '</TD></TR>'."\n";
$info .= '</TABLE></CENTER></FORM><BR>'."\n";

#--- envoi
&confirm_u($info);

