#!/usr/bin/perl

##################################################################
# resp9.pl : affichage des informations des groupes d'un responsable - Projet MINAL2.1
##################################################################

require './minal2.cfg';
require './minal2sp.pl';

#-- module cgi
use CGI qw/:standard/;
$| = 1;
$query = new CGI;

#-- entrees
foreach $key ($query->param()) {
	next if ($key =~ /^\s*$/);
	next if ($query->param($key) =~ /^\s*$/);
	next if ($query->param($key) =~ /<!--(.|\n)*-->/);
	$in{$key} = $query->param($key);
	$in{$key} =~ s/://g;
	$in{$key} =~ s/;//g;
	$in{$key} =~ s/\|//g;
}

#--- pas admin
if ($ENV{REMOTE_USER} eq 'admin'){
	$info .= '<br>Dsol, vous tes administrateur et vous avez votre propre <a href="./adm0.pl">page d\'administration</a><br>'."\n";
	&confirm($info);
}

#--- groupes
@tab = &list_grp;
if (!(@tab)){
	&confirm_u("<center><hr><H1>Problme</H1><hr></center><h2>Aucun groupe d\'utilisateurs n\'est encore dfini...<br><br>Contactez votre responsable</h2>");
}

#--- recup des groupes du resp
@grp = &grp_resp($ENV{REMOTE_USER},'t');
@grp = &classe('ac1','x',@grp);
foreach(@grp){
	$les_grp .= ' <a href="#'.$_.'">'.$_.'</a> '."\n";
}

#--- responsables
%resp = memb_grp('resp','h');

#---identification
$info .= '<CENTER><hr><H1>Affichage des utilisateurs de mes groupes</H1><hr></CENTER><BR>'."\n";
($login,$pw,$uid,$gid,$nompren,$rep,$shell) = &trouve($ENV{REMOTE_USER},1,':',$fic_usr);
$info .= 'Responsable : <b>'.$nompren.'</b><br>'."\n";
if (@grp){
	$info .= 'Groupe : <b>'.$les_grp.'</b><br>&nbsp;<br>&nbsp;'."\n" if (@grp == 1);
	$info .= 'Groupes : <b>'.$les_grp.'</b><br>&nbsp;<br>&nbsp;'."\n" if (@grp > 1);
} else {
	$info  = '<CENTER><hr><H1>Affichage des utilisateurs des groupes que je gre</H1><hr></CENTER><BR>'."\n";
	$info .= 'Dsol, vous n\'tes actuellement responsable d\'aucun groupe d\'utilisateurs, veuillez contacter l\'administrateur du rseau.'."\n";
	&confirm_u($info);
}

foreach $groupo (@grp){
	$info2 .= '<br><h2>Groupe '.$groupo.'</h2><a name="'.$groupo.'"></a>'."\n";
	$info2 .= '<CENTER><table width=590 border=0 cellpadding=5>'."\n";
	$info2 .= '<tr><td width=320><b>Nom, Prnom (login)</b></td><td width=270><b>Caractristiques</b></td></tr>'."\n";
	$info2 .= '<TR><TD colspan=2><hr></TD></TR>'."\n";
	# tous les membres
	@membres_all = &ouvre($fic_usr);
	@membres_all = &classe('ac5',':',@membres_all);
	# membres de ce groupe
	%membo = &memb_grp('grp_'.$groupo,'h');
	# resp de ce groupe
	%resp_du_group = memb_grp('resp_'.$groupo,'h');
	foreach(@membres_all){
		($login,$pw,$uid,$gid,$nompren,$rep,$shell) = split(':',$_);
		next if ($uid < 10001);
		next if (! $membo{$login});
		# c'est un responsable de ce groupe
		if ($resp_du_group{$login}){
			$info2 .= '<tr><td><i>'.$nompren.'</i></td>';
			$info2 .= '<td><i>Responsable de ce groupe</i></td>';
		# c'est un responsable (mais pas de ce groupe)
		} elsif ($resp{$login}){
			$info2 .= '<tr><td><i>'.$nompren.'</i></td>';
			$info2 .= '<td><i>Responsable</i></td>';
		# c'est un utilisateur
		} else {
			$info2 .= '<tr><td>'.$nompren.' ('.$login.')</td>';
			$info2 .= '<td><a href="'.$rep_cgi.'/resp4.pl?login='.$login.'">Modifier</a></td>';
		}
	}
	$info2 .= '</table></center><br><br><br>'."\n";
}

$info .= $info2."\n";

&confirm_u($info);









